Index: example/polynomial.py
===================================================================
--- example/polynomial.py	(revision d19962c0471a0eee538ce03020b5b226ba2752f6)
+++ example/polynomial.py	(revision d19962c0471a0eee538ce03020b5b226ba2752f6)
@@ -0,0 +1,12 @@
+from numpy import inf
+parameters = [
+    ["n", "", 1, [1,5], "", "number of coefficients (or degree+1)"],
+    ["c[n]", "", 0, [-inf, inf], "", "coefficients to c_n x^n"],
+]
+
+Iq = r"""
+    int int_n = (int)n;
+    double result = c[int_n-1];
+    for (int k=int_n-2; k >= 0; k--) { result = result*q + c[k]; }
+    return result;
+    """
Index: sasmodels/bumps_model.py
===================================================================
--- sasmodels/bumps_model.py	(revision ea7504385b3e91f10b68265b8e6a5a5519f04260)
+++ sasmodels/bumps_model.py	(revision 21b116f73d822594145622e342e0308fc3ecd14a)
@@ -81,23 +81,20 @@
     from bumps.names import Parameter
 
-    pars = {}
-    for p in model_info['parameters']:
+    pars = {}     # floating point parameters
+    pd_types = {} # distribution names
+    for p in model_info['parameters'].call_parameters:
         value = kwargs.pop(p.name, p.default)
         pars[p.name] = Parameter.default(value, name=p.name, limits=p.limits)
-    for name in model_info['partype']['pd-2d']:
-        for xpart, xdefault, xlimits in [
-                ('_pd', 0., pars[name].limits),
-                ('_pd_n', 35., (0, 1000)),
-                ('_pd_nsigma', 3., (0, 10)),
-            ]:
-            xname = name + xpart
-            xvalue = kwargs.pop(xname, xdefault)
-            pars[xname] = Parameter.default(xvalue, name=xname, limits=xlimits)
-
-    pd_types = {}
-    for name in model_info['partype']['pd-2d']:
-        xname = name + '_pd_type'
-        xvalue = kwargs.pop(xname, 'gaussian')
-        pd_types[xname] = xvalue
+        if p.polydisperse:
+            for part, default, limits in [
+                    ('_pd', 0., pars[p.name].limits),
+                    ('_pd_n', 35., (0, 1000)),
+                    ('_pd_nsigma', 3., (0, 10)),
+                ]:
+                name = p.name + part
+                value = kwargs.pop(name, default)
+                pars[name] = Parameter.default(value, name=name, limits=limits)
+            name = p.name + '_pd_type'
+            pd_types[name] = kwargs.pop(name, 'gaussian')
 
     if kwargs:  # args not corresponding to parameters
Index: sasmodels/compare.py
===================================================================
--- sasmodels/compare.py	(revision f2473145a6baa12aa3ab15421a80d2f5d004935c)
+++ sasmodels/compare.py	(revision 8bd7b77da137d537b08a21d51f0a8000689d4cc6)
@@ -38,5 +38,4 @@
 from . import core
 from . import kerneldll
-from . import product
 from .data import plot_theory, empty_data1D, empty_data2D
 from .direct_model import DirectModel
@@ -210,4 +209,5 @@
     Choose a parameter range based on parameter name and initial value.
     """
+    # process the polydispersity options
     if p.endswith('_pd_n'):
         return [0, 100]
@@ -222,17 +222,13 @@
         else:
             return [-180, 180]
+    elif p.endswith('_pd'):
+        return [0, 1]
     elif 'sld' in p:
         return [-0.5, 10]
-    elif p.endswith('_pd'):
-        return [0, 1]
     elif p == 'background':
         return [0, 10]
     elif p == 'scale':
         return [0, 1e3]
-    elif p == 'case_num':
-        # RPA hack
-        return [0, 10]
     elif v < 0:
-        # Kxy parameters in rpa model can be negative
         return [2*v, -2*v]
     else:
@@ -240,5 +236,5 @@
 
 
-def _randomize_one(p, v):
+def _randomize_one(model_info, p, v):
     """
     Randomize a single parameter.
@@ -246,9 +242,24 @@
     if any(p.endswith(s) for s in ('_pd_n', '_pd_nsigma', '_pd_type')):
         return v
+
+    # Find the parameter definition
+    for par in model_info['parameters'].call_parameters:
+        if par.name == p:
+            break
     else:
-        return np.random.uniform(*parameter_range(p, v))
-
-
-def randomize_pars(pars, seed=None):
+        raise ValueError("unknown parameter %r"%p)
+
+    if len(par.limits) > 2:  # choice list
+        return np.random.randint(len(par.limits))
+
+    limits = par.limits
+    if not np.isfinite(limits).all():
+        low, high = parameter_range(p, v)
+        limits = (max(limits[0], low), min(limits[1], high))
+
+    return np.random.uniform(*limits)
+
+
+def randomize_pars(model_info, pars, seed=None):
     """
     Generate random values for all of the parameters.
@@ -261,5 +272,5 @@
     with push_seed(seed):
         # Note: the sort guarantees order `of calls to random number generator
-        pars = dict((p, _randomize_one(p, v))
+        pars = dict((p, _randomize_one(model_info, p, v))
                     for p, v in sorted(pars.items()))
     return pars
@@ -294,10 +305,10 @@
         # Make sure phi sums to 1.0
         if pars['case_num'] < 2:
-            pars['Phia'] = 0.
-            pars['Phib'] = 0.
+            pars['Phi1'] = 0.
+            pars['Phi2'] = 0.
         elif pars['case_num'] < 5:
-            pars['Phia'] = 0.
-        total = sum(pars['Phi'+c] for c in 'abcd')
-        for c in 'abcd':
+            pars['Phi1'] = 0.
+        total = sum(pars['Phi'+c] for c in '1234')
+        for c in '1234':
             pars['Phi'+c] /= total
 
@@ -306,19 +317,13 @@
     Format the parameter list for printing.
     """
-    if is2d:
-        exclude = lambda n: False
-    else:
-        partype = model_info['partype']
-        par1d = set(partype['fixed-1d']+partype['pd-1d'])
-        exclude = lambda n: n not in par1d
     lines = []
-    for p in model_info['parameters']:
-        if exclude(p.name): continue
+    parameters = model_info['parameters']
+    for p in parameters.user_parameters(pars, is2d):
         fields = dict(
-            value=pars.get(p.name, p.default),
-            pd=pars.get(p.name+"_pd", 0.),
-            n=int(pars.get(p.name+"_pd_n", 0)),
-            nsigma=pars.get(p.name+"_pd_nsgima", 3.),
-            type=pars.get(p.name+"_pd_type", 'gaussian'))
+            value=pars.get(p.id, p.default),
+            pd=pars.get(p.id+"_pd", 0.),
+            n=int(pars.get(p.id+"_pd_n", 0)),
+            nsigma=pars.get(p.id+"_pd_nsgima", 3.),
+            type=pars.get(p.id+"_pd_type", 'gaussian'))
         lines.append(_format_par(p.name, **fields))
     return "\n".join(lines)
@@ -454,5 +459,6 @@
     """
     # initialize the code so time is more accurate
-    value = calculator(**suppress_pd(pars))
+    if Nevals > 1:
+        value = calculator(**suppress_pd(pars))
     toc = tic()
     for _ in range(max(Nevals, 1)):  # make sure there is at least one eval
@@ -661,13 +667,17 @@
     """
     # Get the default values for the parameters
-    pars = dict((p.name, p.default) for p in model_info['parameters'])
-
-    # Fill in default values for the polydispersity parameters
-    for p in model_info['parameters']:
-        if p.type in ('volume', 'orientation'):
-            pars[p.name+'_pd'] = 0.0
-            pars[p.name+'_pd_n'] = 0
-            pars[p.name+'_pd_nsigma'] = 3.0
-            pars[p.name+'_pd_type'] = "gaussian"
+    pars = {}
+    for p in model_info['parameters'].call_parameters:
+        parts = [('', p.default)]
+        if p.polydisperse:
+            parts.append(('_pd', 0.0))
+            parts.append(('_pd_n', 0))
+            parts.append(('_pd_nsigma', 3.0))
+            parts.append(('_pd_type', "gaussian"))
+        for ext, val in parts:
+            if p.length > 1:
+                dict(("%s%d%s"%(p.id,k,ext), val) for k in range(p.length))
+            else:
+                pars[p.id+ext] = val
 
     # Plug in values given in demo
@@ -774,8 +784,8 @@
 
     if len(engines) == 0:
-        engines.extend(['single', 'sasview'])
+        engines.extend(['single', 'double'])
     elif len(engines) == 1:
-        if engines[0][0] != 'sasview':
-            engines.append('sasview')
+        if engines[0][0] != 'double':
+            engines.append('double')
         else:
             engines.append('single')
@@ -807,5 +817,5 @@
     #pars.update(set_pars)  # set value before random to control range
     if opts['seed'] > -1:
-        pars = randomize_pars(pars, seed=opts['seed'])
+        pars = randomize_pars(model_info, pars, seed=opts['seed'])
         print("Randomize using -random=%i"%opts['seed'])
     if opts['mono']:
@@ -879,12 +889,12 @@
         model_info = opts['def']
         pars, pd_types = bumps_model.create_parameters(model_info, **opts['pars'])
+        # Initialize parameter ranges, fixing the 2D parameters for 1D data.
         if not opts['is2d']:
-            active = [base + ext
-                      for base in model_info['partype']['pd-1d']
-                      for ext in ['', '_pd', '_pd_n', '_pd_nsigma']]
-            active.extend(model_info['partype']['fixed-1d'])
-            for k in active:
-                v = pars[k]
-                v.range(*parameter_range(k, v.value))
+            for p in model_info['parameters'].user_parameters(is2d=False):
+                for ext in ['', '_pd', '_pd_n', '_pd_nsigma']:
+                    k = p.name+ext
+                    v = pars.get(k, None)
+                    if v is not None:
+                        v.range(*parameter_range(k, v.value))
         else:
             for k, v in pars.items():
Index: sasmodels/compare_many.py
===================================================================
--- sasmodels/compare_many.py	(revision ce346b6e747be779612d9528b60d52c717c995af)
+++ sasmodels/compare_many.py	(revision 8bd7b77da137d537b08a21d51f0a8000689d4cc6)
@@ -20,5 +20,4 @@
 
 from . import core
-from . import generate
 from .compare import (MODELS, randomize_pars, suppress_pd, make_data,
                       make_engine, get_pars, columnize,
@@ -109,5 +108,5 @@
 
     if is_2d:
-        if not model_info['has_2d']:
+        if not model_info['parameters'].has_2d:
             print(',"1-D only"')
             return
@@ -125,7 +124,5 @@
         try:
             result = fn(**pars)
-        except KeyboardInterrupt:
-            raise
-        except:
+        except Exception:
             traceback.print_exc()
             print("when comparing %s for %d"%(name, seed))
@@ -246,5 +243,5 @@
         base = sys.argv[5]
         comp = sys.argv[6] if len(sys.argv) > 6 else "sasview"
-    except:
+    except Exception:
         traceback.print_exc()
         print_usage()
Index: sasmodels/convert.py
===================================================================
--- sasmodels/convert.py	(revision f2473145a6baa12aa3ab15421a80d2f5d004935c)
+++ sasmodels/convert.py	(revision 8bd7b77da137d537b08a21d51f0a8000689d4cc6)
@@ -206,5 +206,5 @@
         elif name == 'rpa':
             # convert scattering lengths from femtometers to centimeters
-            for p in "La", "Lb", "Lc", "Ld":
+            for p in "L1", "L2", "L3", "L4":
                 if p in oldpars: oldpars[p] *= 1e-13
         elif name == 'core_shell_parallelepiped':
Index: sasmodels/core.py
===================================================================
--- sasmodels/core.py	(revision 4d767110d389aa65268b4b929ac8df1413460380)
+++ sasmodels/core.py	(revision ee8f73486ed89c512902019a13b040e576091f49)
@@ -24,5 +24,5 @@
     from . import kernelcl
     HAVE_OPENCL = True
-except:
+except Exception:
     HAVE_OPENCL = False
 
@@ -64,5 +64,5 @@
     """
     try: s + ''
-    except: return False
+    except Exception: return False
     return True
 
@@ -170,5 +170,5 @@
 
 
-def get_weights(model_info, pars, name):
+def get_weights(parameter, values):
     """
     Generate the distribution for parameter *name* given the parameter values
@@ -178,11 +178,13 @@
     from the *pars* dictionary for parameter value and parameter dispersion.
     """
-    relative = name in model_info['partype']['pd-rel']
-    limits = model_info['limits'][name]
-    disperser = pars.get(name+'_pd_type', 'gaussian')
-    value = pars.get(name, model_info['defaults'][name])
-    npts = pars.get(name+'_pd_n', 0)
-    width = pars.get(name+'_pd', 0.0)
-    nsigma = pars.get(name+'_pd_nsigma', 3.0)
+    value = float(values.get(parameter.name, parameter.default))
+    relative = parameter.relative_pd
+    limits = parameter.limits
+    disperser = values.get(parameter.name+'_pd_type', 'gaussian')
+    npts = values.get(parameter.name+'_pd_n', 0)
+    width = values.get(parameter.name+'_pd', 0.0)
+    nsigma = values.get(parameter.name+'_pd_nsigma', 3.0)
+    if npts == 0 or width == 0:
+        return [value], []
     value, weight = weights.get_weights(
         disperser, npts, width, nsigma, value, limits, relative)
@@ -198,4 +200,5 @@
     """
     value, weight = zip(*pars)
+    weight = [w if w else [1.] for w in weight]
     value = [v.flatten() for v in meshgrid(*value)]
     weight = np.vstack([v.flatten() for v in meshgrid(*weight)])
@@ -216,12 +219,32 @@
     *mono* is True if polydispersity should be set to none on all parameters.
     """
-    fixed_pars = [pars.get(name, kernel.info['defaults'][name])
-                  for name in kernel.fixed_pars]
+    parameters = kernel.info['parameters']
     if mono:
-        pd_pars = [( np.array([pars[name]]), np.array([1.0]) )
-                   for name in kernel.pd_pars]
-    else:
-        pd_pars = [get_weights(kernel.info, pars, name) for name in kernel.pd_pars]
-    return kernel(fixed_pars, pd_pars, cutoff=cutoff)
+        active = lambda name: False
+    elif kernel.dim == '1d':
+        active = lambda name: name in parameters.pd_1d
+    elif kernel.dim == '2d':
+        active = lambda name: name in parameters.pd_2d
+    else:
+        active = lambda name: True
+
+    vw_pairs = [(get_weights(p, pars) if active(p.name)
+                 else ([pars.get(p.name, p.default)], []))
+                for p in parameters.call_parameters]
+
+    details, weights, values = build_details(kernel, vw_pairs)
+    return kernel(details, weights, values, cutoff)
+
+def build_details(kernel, pairs):
+    values, weights = zip(*pairs)
+    if max([len(w) for w in weights]) > 1:
+        details = generate.poly_details(kernel.info, weights)
+    else:
+        details = kernel.info['mono_details']
+    weights, values = [np.hstack(v) for v in (weights, values)]
+    weights = weights.astype(dtype=kernel.dtype)
+    values = values.astype(dtype=kernel.dtype)
+    return details, weights, values
+
 
 def call_ER_VR(model_info, vol_pars):
@@ -256,9 +279,9 @@
         return 1.0
     else:
-        vol_pars = [get_weights(model_info, values, name)
-                    for name in model_info['partype']['volume']]
+        vol_pars = [get_weights(parameter, values)
+                    for parameter in model_info['parameters'].call_parameters
+                    if parameter.type == 'volume']
         value, weight = dispersion_mesh(vol_pars)
         individual_radii = ER(*value)
-        #print(values[0].shape, weights.shape, fv.shape)
         return np.sum(weight*individual_radii) / np.sum(weight)
 
@@ -273,6 +296,7 @@
         return 1.0
     else:
-        vol_pars = [get_weights(model_info, values, name)
-                    for name in model_info['partype']['volume']]
+        vol_pars = [get_weights(parameter, values)
+                    for parameter in model_info['parameters'].call_parameters
+                    if parameter.type == 'volume']
         value, weight = dispersion_mesh(vol_pars)
         whole, part = VR(*value)
Index: sasmodels/data.py
===================================================================
--- sasmodels/data.py	(revision d6f5da6a131a8de1b3e3d9a12af714a8d32aa4be)
+++ sasmodels/data.py	(revision ee8f73486ed89c512902019a13b040e576091f49)
@@ -358,7 +358,5 @@
         try:
             return fn(*args, **kw)
-        except KeyboardInterrupt:
-            raise
-        except:
+        except Exception:
             traceback.print_exc()
 
Index: sasmodels/direct_model.py
===================================================================
--- sasmodels/direct_model.py	(revision 4d767110d389aa65268b4b929ac8df1413460380)
+++ sasmodels/direct_model.py	(revision ee8f73486ed89c512902019a13b040e576091f49)
@@ -67,6 +67,4 @@
             self.data_type = 'Iq'
 
-        partype = model.info['partype']
-
         if self.data_type == 'sesans':
             
@@ -82,6 +80,6 @@
             q_mono = sesans.make_all_q(data)
         elif self.data_type == 'Iqxy':
-            if not partype['orientation'] and not partype['magnetic']:
-                raise ValueError("not 2D without orientation or magnetic parameters")
+            #if not model.info['parameters'].has_2d:
+            #    raise ValueError("not 2D without orientation or magnetic parameters")
             q = np.sqrt(data.qx_data**2 + data.qy_data**2)
             qmin = getattr(data, 'qmin', 1e-16)
@@ -172,5 +170,5 @@
     def _calc_theory(self, pars, cutoff=0.0):
         if self._kernel is None:
-            self._kernel = self._model.make_kernel(self._kernel_inputs)  # pylint: disable=attribute-dedata_type
+            self._kernel = self._model.make_kernel(self._kernel_inputs)
             self._kernel_mono = (self._model.make_kernel(self._kernel_mono_inputs)
                                  if self._kernel_mono_inputs else None)
@@ -243,5 +241,5 @@
         try:
             values = [float(v) for v in call.split(',')]
-        except:
+        except Exception:
             values = []
         if len(values) == 1:
